> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/networking/sdn/cloud-router/addcloudrouteredgepoints.md).

# AddCloudRouterEdgePoints

## 1. API Description

This API (AddCloudRouterEdgePoints) is used to add Edge Points

{% hint style="info" %}
**Notes**

* Currently only ports with connectivity status **ACTIVE** can be added to a Cloud Router.
* This is an asynchronous API. Once the request is successfully submitted, the operation is not completed immediately. During this period the Cloud Router status will be **UPDATING**; once the edge point is added successfully, the Cloud Router status will change to **RUNNING**.
* No other operations can be performed on the Cloud Router during this period.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type                                                                                                             | Description                                   |
| -------------- | -------- | ---------------------------------------------------------------------------------------------------------------- | --------------------------------------------- |
| cloudRouterId  | Yes      | String                                                                                                           | Cloud Router ID.                              |
| edgePoints     | Yes      | Array of [CreateCloudRouterEdgePoint](/api-reference/networking/sdn/datastructure.md#createcloudrouteredgepoint) | Information about the new edge points to add. |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| edgePointIds   | Array of String | List of newly added edge point IDs, in the same order as the edge points in the request.                              |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Add an edge point to the specified Cloud Router. The edge point is a VPC with an access bandwidth of 1 Mbps.**

```json
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AddCloudRouterEdgePoints
<Common Request Params>

Request:
{
    "cloudRouterId": "your-cloud-router-id",
    "edgePoints": [
        {
            "vpcId":"your vpc id",
            "bandwidthMbps":1
        }
    ]
}

Response:
{   
  "requestId": "T98044459-95B2-477E-9A2F-00253A70CC6E",
  "response": {
     "requestId": "T98044459-95B2-477E-9A2F-00253A70CC6E",
     "edgePointIds": ["edge point id"]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                         | Description                      |
| ---------------- | ---------------------------------- | -------------------------------- |
| 404              | INVALID\_CLOUD\_ROUTER\_NOT\_FOUND | The Cloud Router does not exist. |
